The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::HevyMetl Class Reference

STK heavy metal FM synthesis instrument. More...

`#include <HevyMetl.h>`

Inheritance diagram for stk::HevyMetl:

## Public Member Functions
| HevyMetl (void)
| Class constructor.
| ~HevyMetl (void)
| Class destructor.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.
Public Member Functions inherited from stk::FM
| FM (unsigned int operators=4)
| Class constructor, taking the number of wave/envelope operators to control.
virtual | ~FM (void)
| Class destructor.
void | loadWaves (const char **filenames)
| Load the rawwave filenames in waves.
virtual void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | setRatio (unsigned int waveIndex, StkFloat ratio)
| Set the frequency ratio for the specified wave.
void | setGain (unsigned int waveIndex, StkFloat gain)
| Set the gain for the specified wave.
void | setModulationSpeed (StkFloat mSpeed)
| Set the modulation speed in Hz.
void | setModulationDepth (StkFloat mDepth)
| Set the modulation depth.
void | setControl1 (StkFloat cVal)
| Set the value of control1.
void | setControl2 (StkFloat cVal)
| Set the value of control1.
void | keyOn (void)
| Start envelopes toward "on" targets.
void | keyOff (void)
| Start envelopes toward "off" targets.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
virtual void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
virtual StkFloat | tick (unsigned int)=0
| Compute and return one output sample.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Fill a channel of the StkFrames object with computed outputs.
Public Member Functions inherited from stk::Instrmnt
| Instrmnt (void)
| Class constructor.
virtual void | clear (void)
| Reset and clear all internal state (for subclasses).
virtual void | noteOn (StkFloat frequency, StkFloat amplitude)=0
| Start a note with the given frequency and amplitude.
virtual void | noteOff (StkFloat amplitude)=0
| Stop a note with the given amplitude (speed of decay).
virtual void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
virtual void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed frame.
virtual StkFloat | tick (unsigned int channel=0)=0
| Compute one sample frame and return the specified `channel` value.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Fill the StkFrames object with computed sample frames, starting at the specified channel.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK heavy metal FM synthesis instrument.

This class implements 3 cascade operators with feedback modulation, also referred to as algorithm 3 of the TX81Z.

Algorithm 3 is : 4--\
3-->2-- + -->1-->Out

Control Change Numbers:

- Total Modulator Index = 2
- Modulator Crossfade = 4
- LFO Speed = 11
- LFO Depth = 1
- ADSR 2 & 4 Target = 128

The basic Chowning/Stanford FM patent expired in 1995, but there exist follow-on patents, mostly assigned to Yamaha. If you are of the type who should worry about this (making money) worry away.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ HevyMetl()

stk::HevyMetl::HevyMetl | ( | void |  | ) |

Class constructor.

An StkError will be thrown if the rawwave path is incorrectly set.

## Member Function Documentation

## ◆ tick()

StkFrames & stk::HevyMetl::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::FM.

98{
99 unsigned int nChannels = lastFrame_.channels();
100#if defined(_STK_DEBUG_)
101 if ( channel > frames.channels() - nChannels ) {
102 oStream_ << "HevyMetl::tick(): channel and StkFrames arguments are incompatible!";
103 handleError( StkError::FUNCTION_ARGUMENT );
104 }
105#endif
106
107 StkFloat *samples = &frames[channel];
108 unsigned int j, hop = frames.channels() - nChannels;
109 if ( nChannels == 1 ) {
110 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
111 *samples++ = tick();
112 }
113 else {
114 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
115 *samples++ = tick();
116 for ( j=1; j<nChannels; j++ )
117 *samples++ = lastFrame_[j];
118 }
119 }
120
121 return frames;
122}
stk::HevyMetl::tick
StkFloat tick(unsigned int channel=0)
Compute and return one output sample.
Definition HevyMetl.h:70
stk::StkFrames::channels
unsigned int channels(void) const
Return the number of channels represented by the data.
Definition Stk.h:416
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

The documentation for this class was generated from the following file:

- HevyMetl.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.